---
import type { GetStaticPaths } from 'astro';
import { getCollection } from 'astro:content';
import Pagino from 'pagino';

import Prose from '~/layouts/Prose.astro';
import { env } from '~/lib/env';
import { removeLastPart } from '~/lib/pages';
import { joinPaths } from '~/lib/path';
import { cn } from '~/lib/utils';

export const allPosts = await getCollection('posts');
export const hasPosts = allPosts.length > 0;

export const frontmatter = {
  title: 'Posts',
  description: 'A list of all posts.',
  isPagination: true,
  isIndex: true,
  order: 100,
  hidden: !hasPosts,
};

const allModules = hasPosts ? await Astro.glob('/src/content/posts/*.md') : [];
const EXCERPT_WORDS = 15;

export const getStaticPaths = (async ({ paginate }) => {
  return paginate(allPosts, { pageSize: 1 });
}) satisfies GetStaticPaths;

const { page } = Astro.props;

const pagesBaseUrl = removeLastPart(Astro.url.pathname);

// @ts-ignore
const pagino: Pagino = new Pagino({
  showFirst: true,
  showPrevious: true,
  showNext: true,
  showLast: true,
  page: page.currentPage,
  count: page.lastPage,
  siblingCount: 1,
  boundaryCount: 1,
});
---

<Prose frontmatter={frontmatter}>
  <h1>Posts</h1>
  {
    page.data.map(post => {
      const href = joinPaths(pagesBaseUrl, post.slug, '/');
      const module = allModules.find(m => m.file?.endsWith(`/${post.slug}.md`));
      const excerptFull = module?.frontmatter.excerpt;
      const excerpt =
        excerptFull &&
        excerptFull.split(' ').slice(0, EXCERPT_WORDS).join(' ') +
          (excerptFull.split(' ').length > EXCERPT_WORDS ? '...' : '');
      return (
        <article class="flex flex-col md:justify-end mb-8 md:flex-row-reverse md:items-start">
          {post.data.image && (
            <a class="shrink-0" href={href}>
              <img
                class="w-full rounded-xl my-0 md:w-56 md:mr-4"
                src={joinPaths(env.BASE_URL, post.data.image)}
                alt={post.data.title}
              />
            </a>
          )}
          <div class="mr-auto">
            <h2 class={cn('mb-2', !!post.data.image ? 'mt-2' : 'mt-0')}>
              <a href={href}>{post.data.title}</a>
            </h2>
            {post.data.date && (
              <time datetime={post.data.date.toISOString()}>
                {post.data.date.toLocaleString(undefined, {
                  weekday: 'long',
                  month: 'long',
                  day: 'numeric',
                  year: 'numeric',
                })}
              </time>
            )}
            {excerpt && <p class="mt-2 min-w-24">{excerpt}</p>}
          </div>
        </article>
      );
    })
  }

  <div class="flex w-full justify-center @container">
    <nav
      class="grid @md:flex w-full @md:w-[unset] rounded-lg border divide-y @md:divide-x @md:divide-y-0 text-center bg-secondary text-secondary-foreground"
    >
      {
        pagino.getPages().map(p => {
          if (p === 'next' && page.currentPage < page.lastPage) {
            return (
              <a
                href={joinPaths(pagesBaseUrl, (page.currentPage + 1).toString(), '/')}
                class="px-4 py-2"
              >
                Next
              </a>
            );
          } else if (p === 'previous' && page.currentPage > 1) {
            return (
              <a
                href={joinPaths(pagesBaseUrl, (page.currentPage - 1).toString(), '/')}
                class="px-4 py-2"
              >
                Previous
              </a>
            );
          } else if (p === 'first') {
            return (
              <a href={joinPaths(pagesBaseUrl, '1', '/')} class="px-4 py-2">
                First
              </a>
            );
          } else if (p === 'last') {
            return (
              <a href={joinPaths(pagesBaseUrl, page.lastPage.toString(), '/')} class="px-4 py-2">
                Last
              </a>
            );
          } else if (p === 'ellipsis') {
            return <span class="px-4 py-2">&hellip;</span>;
          } else if (p === page.currentPage) {
            return (
              <a
                href={joinPaths(pagesBaseUrl, p.toString(), '/')}
                class="px-4 py-2 font-bold bg-primary text-primary-foreground"
                aria-current="page"
              >
                {p}
              </a>
            );
          } else if (typeof p === 'number') {
            return (
              <a href={joinPaths(pagesBaseUrl, p.toString(), '/')} class="px-4 py-2">
                {p}
              </a>
            );
          }
        })
      }
    </nav>
  </div>
</Prose>
